* GUT, J.A.W. Programao Matemtica para Otimizao de Processos. EDUSP 2021.
* https://sites.usp.br/otimizacao/
***** Problema de projeto timo ***************************
***** Declarao de variveis *****************************
FREE VARIABLES f ;
POSITIVE VARIABLES v1, v2, v3, n1, n2, n3, bA, bB, tlA, tlB ;
BINARY VARIABLES y11, y12, y13, y21, y22, y23, y31, y32, y33;
***** Declarao de equaes ******************************
EQUATIONS h0, h1, h2, h3, h4, h5, h6,
g1, g2, g3, g4, g5, g6, g7, g8, g9, g10, g11, g12, g13;
***** Equaes ********************************************
* objetivo: custo das maquinas nos 3 estagios
h0..  f -250*EXP(n1+0.6*v1) -250*EXP(n2+0.6*v2) -250*EXP(n3+0.6*v3) =E= 0 ;
* restries de volume, estgios 1, 2 e 3
g1.. LOG(2) + bA - v1 =L= 0 ;
g2.. LOG(4) + bB - v1 =L= 0 ;
g3.. LOG(3) + bA - v2 =L= 0 ;
g4.. LOG(6) + bB - v2 =L= 0 ;
g5.. LOG(4) + bA - v3 =L= 0 ;
g6.. LOG(3) + bB - v3 =L= 0 ;
* restries de tempo de ciclo, produtos A e B
g7.. LOG(8)  - n1 - tlA =L= 0 ;
g8.. LOG(20) - n2 - tlA =L= 0 ;
g9.. LOG(8)  - n3 - tlA =L= 0 ;
g10.. LOG(16) - n1 - tlB =L= 0 ;
g11.. LOG(4)  - n2 - tlB =L= 0 ;
g12.. LOG(4)  - n3 - tlB =L= 0 ;
* restrio de horizonte de tempo
g13.. 200*EXP(tlA-bA) + 100*EXP(tlB-bB) -6 =L= 0 ;
* restrie de nmero de mquinas em paralelo nos estgios
h1.. n1 - Y11*LOG(1) - Y12*LOG(2) - Y13*LOG(3) =E= 0 ;
h2.. n2 - Y21*LOG(1) - Y22*LOG(2) - Y23*LOG(3) =E= 0 ;
h3.. n3 - Y31*LOG(1) - Y32*LOG(2) - Y33*LOG(3) =E= 0 ;
h4.. Y11 + Y12 + Y13 -1 =E= 0 ;
h5.. Y21 + Y22 + Y23 -1 =E= 0 ;
h6.. Y31 + Y32 + Y33 -1 =E= 0 ;
* limites para volume das mquinas nos estgios 1, 2 e 3
v1.LO = LOG(250)  ;
v1.UP = LOG(2500) ;
v2.LO = LOG(250)  ;
v2.UP = LOG(2500) ;
v3.LO = LOG(250)  ;
v3.UP = LOG(2500) ;
* limites para tempo de ciclo, produtos A e B
tlA.LO = LOG(20/3) ;
tlA.UP = LOG(20)   ;
tlB.LO = LOG(16/3) ;
tlB.UP = LOG(16)   ;
* limites para tamanho de batelada, produtos A e B
bA.LO = LOG((200/6)*(20/3)) ;
bA.UP = LOG(2500/4) ;
bB.LO = LOG((100/6)*(16/6))  ;
bB.UP = LOG(2500/6) ;
***** Soluo do problema *********************************
MODEL projeto / ALL  / ;
SOLVE projeto USING MINLP MINIMIZING f;
***********************************************************
